
JSB.newAddon = function (mainPath) {
  JSB.require('utils');
  if (!timerUtils.checkMNUtilsFolder(mainPath)) {return undefined}
  JSB.require('webviewController');
  JSB.require('settingController');
    // NSUserDefaults.standardUserDefaults().removeObjectForKey("MNTimer_entrieNames")
    // NSUserDefaults.standardUserDefaults().removeObjectForKey("MNTimer_entries")
    // NSUserDefaults.standardUserDefaults().removeObjectForKey('MNTimer_engine');
    // NSUserDefaults.standardUserDefaults().removeObjectForKey("MNTimer_webAppEntrieNames")
    // NSUserDefaults.standardUserDefaults().removeObjectForKey("MNTimer_webAppEntries")
    // NSUserDefaults.standardUserDefaults().removeObjectForKey('MNTimer_webApp');
    // NSUserDefaults.standardUserDefaults().removeObjectForKey('MNTimer_toolbar');
    // NSUserDefaults.standardUserDefaults().removeObjectForKey('MNTimer_onNewExcerpt');
    // NSUserDefaults.standardUserDefaults().removeObjectForKey('MNTimer_dynamic');
  var temSender;
  
  /** @return {MNTimerClass} */
  const getMNTimerClass = ()=>self
  var MNTimerClass = JSB.defineClass(
    'MNTimer : JSExtension',
    { /* Instance members */
      sceneWillConnect: async function () { //Window initialize
        if (!(await timerUtils.checkMNUtil(true))) return
        let self = getMNTimerClass()
        self.init(mainPath)
        self.watchMode = false;
        self.textSelected = ""
        self.textProcessed = false;
        self.dateGetText = Date.now();
        self.dateNow = Date.now();
        self.rect = '{{0, 0}, {10, 10}}';
        self.arrow = 1;
        self.isFirst = true;
        self.linkDetected = false
      },

      sceneDidDisconnect: function () { // Window disconnect

      },

      sceneWillResignActive: function () { // Window resign active
      },

      sceneDidBecomeActive: function () { // Window become active
      },

      notebookWillOpen: async function (notebookid) {
        if (!(await timerUtils.checkMNUtil(true,0.1))) return
      try {
        let self = getMNTimerClass()
        self.init(mainPath)
        self.ensureView()
        // if (self.appInstance.studyController(self.window).studyMode < 3) {
        self.appInstance = Application.sharedInstance();
        MNUtil.currentWindow.addSubview(self.addonController.view)
        // self.addonController = timerController.new();
        // MNUtil.studyView.addSubview(self.addonController.view)
        // MNUtil.refreshAddonCommands()
        // self.addonController.view.hidden = true;
        self.addonController.notebookid = notebookid
        // MNUtil.addObserver(self, 'onPopupMenuOnSelection:', 'PopupMenuOnSelection')
        // MNUtil.addObserver(self, 'onPopupMenuOnNote:', 'PopupMenuOnNote');
        // MNUtil.addObserver(self, 'onProcessNewExcerpt:', 'ProcessNewExcerpt');
        // MNUtil.addObserver(self, 'receivedSearchInBrowser:', 'searchInBrowser');
        // MNUtil.addObserver(self, 'receivedOpenInBrowser:', 'openInBrowser');
        // MNUtil.addObserver(self, 'onNewWindow:', 'newWindow');
        MNUtil.addObserver(self, 'onRefreshSubview:', 'refreshSubview');
        // MNUtil.addObserver(self, 'onAddonBroadcast:', 'AddonBroadcast');
        // MNUtil.addObserver(self, 'onPasteboardChange:', 'UIPasteboardChangedNotification');
        // MNUtil.addObserver(self, 'onPasteboardChange:', 'UIPasteboardChangedTypesAddedKey');
        // MNUtil.addObserver(self, 'onPasteboardChange:', 'UIPasteboardChangedTypesRemovedKey');
        // MNUtil.addObserver(self, 'onPasteboardChange:', 'UIPasteboardRemovedNotification');
        self.addonController.webAppButton.hidden = true
        // self.addonController.webAppEntriesButton.hidden = !toolbar
        self.addonController.homeButton.hidden = true
        self.addonController.goBackButton.hidden = true
        self.addonController.goForwardButton.hidden = true
        self.addonController.refreshButton.hidden = true
        self.addonController.engineButton.hidden = true
        MNUtil.delay(0.1).then(()=>{
          MNUtil.studyView.becomeFirstResponder()
        })
        } catch (error) {
          timerUtils.addErrorLog(error, "notebookWillOpen")
        }
      },

      notebookWillClose: function (notebookid) {
        // if (typeof MNUtil === 'undefined') {
        //   return
        // }
        // MNUtil.showHUD("notebookWillClose")
        // Application.sharedInstance().showHUD("close",self.window,2)
        // if (self.addonController.miniMode) {
        //   // self.addonController.clearContent()
        //   self.addonController.homePage()
        //   let preFrame = self.addonController.view.frame
        //   self.addonController.view.hidden = true
        //   self.addonController.showAllButton()
        //   let studyFrame = Application.sharedInstance().studyController(self.window).view.bounds
        //   if (self.addonController.view.frame.x < studyFrame.width*0.5) {
        //     self.addonController.lastFrame.x = 0
        //   }else{
        //     self.addonController.lastFrame.x = studyFrame.width-self.addonController.lastFrame.width
        //   }
        //   self.addonController.setFrame(self.addonController.lastFrame)
        //   self.addonController.show(preFrame)
        // }
        // self.addonController.view.removeFromSuperview()
        // self.newWindowController.view.removeFromSuperview()
      },

      documentDidOpen: function (docmd5) {
      },

      documentWillClose: function (docmd5) {
      },

      controllerWillLayoutSubviews: function (controller) {
        if (typeof MNUtil === 'undefined') {
          return
        }
        // MNUtil.mindmapView.superview.subviews.at(-4).hidden = true
        
        // MNUtil.mindmapView.superview.subviews.at(-6).hidden = true
        // MNUtil.mindmapView.superview.subviews.at(-7).hidden = true
        // MNUtil.mindmapView.superview.subviews.at(-8).hidden = true
        // let tem = MNUtil.mindmapView.superview.subviews.at(-1)
        // tem.hidden = tem.subviews.length === 9
        // MNUtil.mindmapView.superview.subviews.at(-1).subviews[3].hidden = true
        // MNUtil.mindmapView.superview.subviews.at(-1).subviews[4].hidden = true
        // MNUtil.mindmapView.superview.subviews.at(-1).subviews[5].hidden = true

        // if (controller !== MNUtil.studyController) {
        //     MNUtil.showHUD("reject")
        //   return;
        // };
        if (self.window !== MNUtil.currentWindow) {
            // MNUtil.showHUD("reject")
          return;
        };
        if (!self.addonController.view.hidden && !self.addonController.onAnimate) {
          let studyFrame = MNUtil.currentWindow.bounds
          if (self.addonController.miniMode) {
            let oldFrame = self.addonController.view.frame
            // MNUtil.showHUD("message")
            if (self.addonController.hasTodoText) {

              self.addonController.view.frame = { x: oldFrame.x, y: oldFrame.y, width: 200, height: 110 }
            }else{

              self.addonController.view.frame = { x: oldFrame.x, y: oldFrame.y, width: 200, height: 70 }
            }
          } else if (self.addonController.custom) {
            self.addonController.setSplitScreenFrame(self.addonController.customMode)
            self.addonController.webview.frame = self.addonController.view.bounds
          }else{
            let currentFrame = self.addonController.currentFrame
            if (currentFrame.x+currentFrame.width*0.5 >= studyFrame.width) {
              currentFrame.x = studyFrame.width-currentFrame.width*0.5              
            }
            if (currentFrame.y >= studyFrame.height) {
              currentFrame.y = studyFrame.height-20              
            }
            self.addonController.setFrame(currentFrame)
          }
        }
        // if (!self.newWindowController || self.newWindowController.view.hidden) {return}
        // let studyFrame = MNUtil.studyView.bounds
        // if (self.newWindowController.miniMode) {
        //   let oldFrame = self.newWindowController.view.frame
        //   if (oldFrame.x < studyFrame.width*0.5) {
        //     self.newWindowController.view.frame = { x: 0, y: oldFrame.y, width: 40, height: oldFrame.height }
        //   } else {
        //     self.newWindowController.view.frame = { x: studyFrame.width - 40, y: oldFrame.y, width: 40, height: oldFrame.height }
        //   }
        // } else if (self.newWindowController.custom) {
        //   self.addonController.setSplitScreenFrame(self.addonController.customMode)
        //   self.newWindowController.webview.frame = self.newWindowController.view.bounds
        // }else{
        //   let currentFrame = self.newWindowController.currentFrame
        //   if (currentFrame.x+currentFrame.width*0.5 >= studyFrame.width) {
        //     currentFrame.x = studyFrame.width-currentFrame.width*0.5              
        //   }
        //   if (currentFrame.y >= studyFrame.height) {
        //     currentFrame.y = studyFrame.height-20              
        //   }
        //   self.newWindowController.setFrame(currentFrame)
        // }
      },

      queryAddonCommandStatus: function () {
        if (!timerUtils.checkLogo()) {
          return null
        }
        self.ensureView(false)
        if (self.linkDetected) {
          return {
            image: 'link.png',
            object: self,
            selector: 'toggleAddon:',
            checked: true
          };
        }else{
          return {
            image: 'logo.png',
            object: self,
            selector: 'toggleAddon:',
            checked: self.watchMode
          };
        }
      },
      onNewWindow: function (sender) {
        if (typeof MNUtil === 'undefined') {
          return
        }
        if (self.window !== MNUtil.currentWindow) {
          // MNUtil.showHUD("reject")
          return
        }
        if (!self.newWindowController) {
          self.newWindowController = timerController.new();
          self.newWindowController.addonBar = self.addonController.addonBar
          self.newWindowController.view.hidden = true
          MNUtil.studyView.addSubview(self.newWindowController.view);
          self.newWindowController.setFrame(50,100,417,450)
        }
        if (self.newWindowController.view.hidden) {
          self.newWindowController.show(self.newWindowController.addonBar.frame)
        }
        try {
        if (sender.userInfo.desktop) {
          self.newWindowController.webview.customUserAgent = 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/16.0 Safari/605.1.15'
        }else{
          self.newWindowController.webview.customUserAgent = 'Mozilla/5.0 (iPhone; CPU iPhone OS 15_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148'
        }
        let toolbar = timerConfig.toolbar
        self.newWindowController.webAppButton.hidden = !toolbar
        // self.newWindowController.webAppEntriesButton.hidden = !toolbar
        self.newWindowController.homeButton.hidden = !toolbar
        self.newWindowController.goBackButton.hidden = !toolbar
        self.newWindowController.goForwardButton.hidden = !toolbar
        self.newWindowController.refreshButton.hidden = !toolbar
        self.newWindowController.engineButton.hidden = !toolbar
        self.newWindowController.customButton1.hidden = !toolbar
        self.newWindowController.customButton2.hidden = !toolbar
        self.newWindowController.customButton3.hidden = !toolbar
        var viewFrame = self.newWindowController.view.bounds;
        if (timerConfig.toolbar) {
          self.newWindowController.webview.frame = { x: viewFrame.x + 1, y: viewFrame.y + 10, width: viewFrame.width - 2, height: viewFrame.height - 40 }
        } else {
          self.newWindowController.webview.frame = { x: viewFrame.x + 1, y: viewFrame.y + 10, width: viewFrame.width - 2, height: viewFrame.height }
        }
        self.newWindowController.isMainWindow = false
        self.newWindowController.webview.hidden = false;
        if (sender.userInfo.agent) {
          self.newWindowController.webview.customUserAgent = sender.userInfo.agent
        }
        // Application.sharedInstance().showHUD(userInfo.url, self.window, 5);
        MNConnection.loadRequest(self.newWindowController.webview, sender.userInfo.url)
        // self.newWindowController.webview.loadRequest(MNUtil.requestWithURL(sender.userInfo.url));
        } catch (error) {
          timerUtils.addErrorLog(error, "onNewWindow")
        }
      },
      onPasteboardChange: function () {
        if (typeof MNUtil === 'undefined') {
          return
        }
        MNUtil.showHUD("check:")

      },
      onAddonBroadcast: function (sender) {
        if (self.window!==MNUtil.currentWindow) {
          return
        }
        try {
          
        let message = sender.userInfo.message
        if (/BilibiliExcerpt\?/.test(message)) {
          let arguments = message.match(/(?<=BilibiliExcerpt\?).*/)[0].split("&")
          let id = arguments[0].match(/(?<=videoId\=)\w+/)[0]
          let time = arguments[1].match(/(?<=t\=).*/)[0]
          if (self.addonController.view.hidden) {
            // MNUtil.showHUD("message")
            self.addonController.show()
          }
          if (arguments.length > 2) {
            let p = arguments[2].match(/(?<=p\=).*/)[0]
            self.addonController.openOrJump(id,time,parseInt(p))
          }else{
            self.addonController.openOrJump(id,time,0)
          }
          MNUtil.studyView.bringSubviewToFront(self.addonController.view)
        }
        if (/YoutubeExcerpt\?/.test(message)) {
          let arguments = message.match(/(?<=YoutubeExcerpt\?).*/)[0].split("&")
          let id = arguments[0].match(/(?<=videoId\=)\w+/)[0]
          let time = arguments[1].match(/(?<=t\=).*/)[0]
          if (self.addonController.view.hidden) {
            // MNUtil.showHUD("message")
            self.addonController.show()
          }
          self.addonController.openOrJumpForYT(id,time)
          MNUtil.studyView.bringSubviewToFront(self.addonController.view)
        }
        } catch (error) {
          timerUtils.addErrorLog(error, "onAddonBroadcast")
        }
      },
      receivedSearchInBrowser: function (sender) {
        if (typeof MNUtil === 'undefined') {
          return
        }
        // Application.sharedInstance().showHUD("check:",self.appInstance.focusWindow,2)
        if (self.window!==self.appInstance.focusWindow) {
          return
        }
        // MNUtil.copyJSON(sender.userInfo)
        if (sender.userInfo.noteid) {
          let note = MNUtil.getNoteById(sender.userInfo.noteid)
          let text = self.getTextForSearch(note)
          self.addonController.selectedText = text
          self.addonController.search(self.textSelected)
        }else if(sender.userInfo.text){
          self.textSelected = encodeURIComponent(sender.userInfo.text.replaceAll('/', '\\/'));
          self.addonController.selectedText = self.textSelected
          self.addonController.search(self.textSelected)
        }
        if (!self.addonController.view.hidden) {
          return
        }
        if (sender.userInfo.beginFrame && sender.userInfo.endFrame) {
          self.addonController.show(sender.userInfo.beginFrame,sender.userInfo.endFrame)
          MNUtil.studyView.bringSubviewToFront(self.addonController.view)
          return
        }
        self.addonController.show()
        MNUtil.studyView.bringSubviewToFront(self.addonController.view)
      },
      receivedOpenInBrowser: function (sender) {
        if (typeof MNUtil === 'undefined') {
          return
        }
        if (self.window!==self.appInstance.focusWindow) {
          return
        }
        MNConnection.loadRequest(self.addonController.webview, sender.userInfo.url)
        // self.addonController.webview.loadRequest(
        //     NSURLRequest.requestWithURL(NSURL.URLWithString(sender.userInfo.url))
        //   );
        if (!self.addonController.view.hidden) {
          return
        }
        if (sender.userInfo.beginFrame && sender.userInfo.endFrame) {
          self.addonController.show(sender.userInfo.beginFrame,sender.userInfo.endFrame)
          return
        }
        self.addonController.show()
      },
      onRefreshSubview: function (sender) {
        if (typeof MNUtil === 'undefined') {
          return
        }
        if (self.window!==self.appInstance.focusWindow) {
          return
        }
        // MNUtil.copyJSON(sender.userInfo)
        self.refreshSubview()
      },
      toggleAddon: async function (sender) {
        // MNUtil.mindmapView.hidden = true
        // MNUtil.mindmapView.superview.subviews.at(-4).hidden = true

        // let tem = MNUtil.mindmapView.superview.subviews.at(-1)
        // MNUtil.showHUD("message"+tem.subviews.length)
        // MNUtil.openURL("file://"+timerUtils.mainPath+"/test.pdf")
        if (typeof MNUtil === 'undefined') {
          return
        }
        try {

          
        self.ensureView()
        if (!self.addonBar) {
          self.addonBar = sender.superview.superview
          self.addonController.addonBar = self.addonBar
        }
        // if (self.checkWatchMode()) { return }
        // if (self.checkLink()) { return }

        if (self.addonController.view.hidden) {
          if (self.isFirst) {
            // Application.sharedInstance().showHUD("first",self.window,2)
            let buttonFrame = self.addonBar.frame
            let width = 500
            if (buttonFrame.x === 0) {
              self.addonController.setFrame(40,buttonFrame.y,width,350)
            }else{
              self.addonController.setFrame(buttonFrame.x-width,buttonFrame.y,width,350)
            }
            self.isFirst = false;
          }
        // MNUtil.showHUD("message"+timerConfig.toolbar)
          MNUtil.studyView.bringSubviewToFront(self.addonBar)
          // self.addonController.homePage()
          self.addonController.show()
          // self.addonController.view.hidden = false
          // self.addonController.webview.hidden = false
        } else {
            // self.addonController.view.hidden = true;
            if (self.addonController.miniMode) {
              let preFrame = self.addonController.view.frame
              self.addonController.showAllButton()
              let studyFrame = MNUtil.studyView.bounds
              if (self.addonController.view.frame.x < studyFrame.width*0.5) {
                self.addonController.lastFrame.x = 0
              }else{
                self.addonController.lastFrame.x = studyFrame.width-self.addonController.lastFrame.width
              }
              self.addonController.setFrame(self.addonController.lastFrame)
              MNUtil.studyView.bringSubviewToFront(self.addonBar)
              self.addonController.show(preFrame)
            }else{
              await self.addonController.hide()
              self.addonController.webview.removeFromSuperview();
            }
            self.watchMode = false;
            MNUtil.refreshAddonCommands()
            return;
        }
  
} catch (error) {
    timerUtils.addErrorLog(error, "toggleAddon")
}
      },
    },
    { /* Class members */
      addonDidConnect: function () {
      },

      addonWillDisconnect: async function () {
        let confirm = await MNUtil.confirm("MN Timer: Remove all config?\n删除所有配置？", "")
        if (!confirm) {
          return
        }
        timerConfig.entries = timerConfig.defaultEntries
        timerConfig.entrieNames = Object.keys(timerConfig.entries)
        timerConfig.engine = timerConfig.entrieNames[0]
        timerConfig.webAppEntries = timerConfig.defaultWebAppEntries
        timerConfig.webAppEntrieNames = Object.keys(timerConfig.webAppEntries)
        timerConfig.toolbar = true
        timerConfig.engine = "Bing"
        timerConfig.dynamic = false
        timerConfig.remove("MNTimer_entrieNames")
        timerConfig.remove("MNTimer_entries")
        timerConfig.remove('MNTimer_engine');
        timerConfig.remove("MNTimer_webAppEntrieNames")
        timerConfig.remove("MNTimer_webAppEntries")
        timerConfig.remove('MNTimer_webApp');
        timerConfig.remove('MNTimer_toolbar');
        timerConfig.remove('MNTimer_onNewExcerpt');
        timerConfig.remove('MNTimer_dynamic');
      },

      applicationWillEnterForeground: function () {
        // MNUtil.postNotification("refreshSubview", {})
      },

      applicationDidEnterBackground: function () {
      },

      applicationDidReceiveLocalNotification: function (notify) {
      }
    }
  );

  MNTimerClass.prototype.layoutAddonController = function (rectStr, arrowNum) {
    this.rect = rectStr || this.rect;
    this.arrow = arrowNum || this.arrow;
    var x, y
    w = (MNUtil.app.osType !== 1) ? 419 : 365, // this.addonController.view.frame.width
      h = 500, // this.addonController.view.frame.height
      fontSize = 15,
      margin = 10,
      padding = 20,
      frame = MNUtil.studyView.bounds,
      W = frame.width,
      H = frame.height,
      rectArr = this.rect.replace(/{/g, '').replace(/}/g, '').replace(/\s/g, '').split(','),
      X = Number(rectArr[0]),
      Y = Number(rectArr[1]),
      studyMode = MNUtil.studyController.studyMode,
      contextMenuWidth = studyMode === 0 ? 225 : 435,
      contextMenuHeight = 35,
      textMenuPadding = 40;

    // this.addonController.view.frame.x
    if (w >= contextMenuWidth) {
      if (X - w / 2 - margin <= 0) {
        x = margin;
      } else if (X + w / 2 + margin >= W) {
        x = W - margin - w;
      } else {
        x = X - w / 2;
      }
    } else {
      if (X - contextMenuWidth / 2 - margin <= 0) {
        x = margin + contextMenuWidth / 2 - w / 2;
      } else if (X + contextMenuWidth / 2 + margin >= W) {
        x = W - margin - contextMenuWidth / 2 - w / 2;
      } else {
        x = X - w / 2;
      }
    }

    // this.addonController.view.frame.[y, height]
    if (this.arrow === 1) {
      let upperBlankHeight = Y - textMenuPadding - fontSize - padding,
        lowerBlankHeight = H - Y - contextMenuHeight - padding;
      if (upperBlankHeight >= lowerBlankHeight) {
        h = (upperBlankHeight >= h) ? h : upperBlankHeight;
        y = upperBlankHeight - h;
      } else {
        y = H - lowerBlankHeight;
        h = (H - y >= h) ? h : H - y;
    // this.appInstance.showHUD('x:'+x+';y:'+Y,this.window,2)
      }
    } else {
      let upperBlankHeight = Y - textMenuPadding - contextMenuHeight - padding,
        lowerBlankHeight = H - Y - fontSize - padding;
      if (upperBlankHeight >= lowerBlankHeight) {
        h = (upperBlankHeight >= h) ? h : upperBlankHeight;
        y = upperBlankHeight - h;
      } else {
        y = H - lowerBlankHeight;
        h = (H - y >= h) ? h : H - y;
      }
    }
    MNUtil.animate(()=>{
      this.addonController.setFrame(x,y,w,h)
    })
  };
  MNTimerClass.prototype.checkWatchMode = function () {
    if (Date.now() - this.dateNow < 500) {
      this.watchMode = true;
      MNUtil.showHUD("Watch mode")
      MNUtil.refreshAddonCommands()
      this.addonController.webview.hidden = false
      this.addonController.view.hidden = false
      this.addonController.showAllButton()

      // if (this.addonController.view.hidden) {
      //   this.addonController.show(this.addonBar.frame)
      // }
      return true;
    }else{
      this.dateNow = Date.now()
      return false
    }
  };
  MNTimerClass.prototype.checkLink = function () {
     if (this.linkDetected) {
      MNConnection.loadRequest(this.addonController.webview, this.link)
      if (this.addonController.view.hidden) {
        this.addonController.show(this.addonBar.frame)
      }
      return true
    }
    return false
  }
  MNTimerClass.prototype.getNoteList = function (note) {
    let noteList = []
    if (note.noteTitle) {
      noteList.push(note.noteTitle)
    }
    if (note.excerptText && !note.excerptPic) {
      noteList.push(note.excerptText)
    }
    return noteList.concat(note.comments.filter(comment=>comment.type==="TextNote").map(comment=>comment.text))
  };
  MNTimerClass.prototype.getTextForSearch = function (note) {
    let order = timerConfig.searchOrder
    if (!order) {
      order = [2,1,3]
    }
    let text
    for (let index = 0; index < order.length; index++) {
      const element = order[index];
      switch (element) {
        case 1:
          if (note.noteTitle && note.noteTitle !== "") {
            text = note.noteTitle
          }
          break;
        case 2:
          if (note.excerptText && note.excerptText !== "" && (!note.excerptPic || note.textFirst)) {
            text = note.excerptText
          }
          break;
        case 3:
          let noteText  = note.comments.filter(comment=>comment.type === "TextNote" && !/^marginnote3app:\/\//.test(comment.text))
          if (noteText.length) {
            text =  noteText[0].text
          }
          break;
        default:
          break;
      }
      if (text) {
        return text
      }
    }
  return ""
  }
  MNTimerClass.prototype.init = function(mainPath){ 
  try {
    if (!this.initialized) {
      timerUtils.init(mainPath)
      timerConfig.init()
      this.initialized = true
    }
    if (!this.addonController) {
      this.addonController = timerController.new();
    }
  } catch (error) {
    chatAIUtils.addErrorLog(error, "init")
  }
  }
  MNTimerClass.prototype.ensureView = function (refresh = true) {
  try {
    // if (!MNUtil.isDescendantOfStudyView(this.addonController.view)) {
    //   MNUtil.studyView.addSubview(this.addonController.view)
    //   this.addonController.view.hidden = true
    //   if (refresh) {
    //     MNUtil.refreshAddonCommands()
    //   }
    //   this.addonController.view.hidden = !this.addonController.timerOn
    //   this.addonController.homePage()
    // }
    if (this.addonController.view.isDescendantOfView(MNUtil.currentWindow)) {
      MNUtil.currentWindow.addSubview(this.addonController.view)
      this.addonController.view.hidden = true
      if (refresh) {
        MNUtil.refreshAddonCommands()
      }
      this.addonController.view.hidden = !this.addonController.timerOn
      this.addonController.homePage()
    }
      } catch (error) {
    timerUtils.showHUD(error,5)
  }
  }
  MNTimerClass.prototype.refreshSubview = function (params) {
    MNUtil.showHUD("refreshSubview")
    if (!this.addonController.view.hidden && !this.addonController.onAnimate) {
      let studyFrame = MNUtil.currentWindow.bounds
      if (this.addonController.miniMode) {
        let oldFrame = this.addonController.view.frame
        this.addonController.view.frame = { x: oldFrame.x, y: oldFrame.y, width: 200, height: 70 }
      } else if (this.addonController.custom) {
        this.addonController.setSplitScreenFrame(this.addonController.customMode)
        this.addonController.webview.frame = this.addonController.view.bounds
      }else{
        let currentFrame = this.addonController.currentFrame
        if (currentFrame.x+currentFrame.width*0.5 >= studyFrame.width) {
          currentFrame.x = studyFrame.width-currentFrame.width*0.5              
        }
        if (currentFrame.y >= studyFrame.height) {
          currentFrame.y = studyFrame.height-20              
        }
        this.addonController.setFrame(currentFrame)
      }
    }
  }
  return MNTimerClass;
};

